/* Copyright (C) 2001  Martin J. Muench <muench@gmc-online.de> */                                   

#include "config.h"

extern void end_curses();
extern void enigma(char *, int);

/* Send our ICMP packet */
void sendpacket(char *text, char *host) {
	int             pktsize;
	char		*packet, *data, stext[CHARPERLINE + strlen(SID)];
	
	pktsize = sizeof(struct icmp) + CHARPERLINE;
        
        if(!(packet = (char *)malloc(pktsize)))
		end_curses(), close(rawsock), perror("Malloc:"), exit(-1); 
                
	/* Add structure to packet */
        icmp = ( struct icmp * )packet;
        data = (char *)(packet + sizeof(struct icmp) );
	memset(packet,0,pktsize);

	/* Set packet options */
	saddr.sin_family=AF_INET;
	saddr.sin_addr.s_addr=inet_addr(host);
	icmp->icmp_type = icmpcode;
	icmp->icmp_cksum = 0;

	/* Include SessionID */
	strncpy(stext, SID, strlen(SID));
	stext[strlen(SID)]='\0';
	strncat(stext, text, strlen(text));

	/* Crypt before send */
	enigma(stext, strlen(stext));
	
	/* Add text to package */
	strncat(data,enicrypt,sizeof(enicrypt));

	/* Make checksum */
        icmp->icmp_cksum = in_cksum((u_short *)icmp,sizeof(struct icmp) + CHARPERLINE);

	/* Send packet */
	if (sendto(rawsock, packet, pktsize, 0,  (struct sockaddr *)&saddr, sizeof(struct sockaddr)) < 0 )
		end_curses(), close(rawsock), perror("SendError:"), exit(-1);
}

/* Copied from FreeBSD ping.c  */
int in_cksum (u_short *addr, int len) {
	register int nleft = len;
	register u_short *w = addr;
	register int sum = 0;
	u_short answer = 0;
	while (nleft > 1) 
		sum += *w++, nleft -= 2;

	if (nleft == 1)
		*(u_char *)(&answer) = *(u_char *)w; sum += answer;
		
	sum = (sum >> 16) + (sum & 0xffff);
	sum += (sum >> 16);
	answer = ~sum;
	return (answer);
}
