#include "config.h"

struct hostent * Gethostbyname ( char * host) {
  struct hostent * temp;
  temp = Malloc(sizeof(struct hostent *));
  temp = gethostbyname(host);
  if (!temp) 
    perror("Hostname:"), exit(-1);

  return temp;
}


char * Getpass(char *msg) {
  char *oldbuf, *pw;
  int  i, len;
  
  oldbuf = getpass(msg);
  if (!oldbuf) 
	perror("Password:"), exit(-1);
  
  len = strlen(oldbuf);
  pw = Malloc(sizeof(char) * len < 8 ? 9 : len);
  pw = Strdup(oldbuf);

  while(len < 8) 
    *(pw + len++) = 'a';

  return pw;
}

 
int get_raw_sock (void) {
 int sock, null = 0;

 if ((sock=socket(AF_INET,SOCK_RAW,IPPROTO_ICMP)) < 0) 
 	end_curses(), perror("RawSocket:"), exit(-1); 

 if (setsockopt(sock,IPPROTO_IP,IP_HDRINCL,&null,sizeof(null)) < 0) 
 	close(sock), end_curses(), perror("SetSockOpt:"), exit(-1); 

 return sock;
}


int Select(int max, fd_set *readset) {
  int numActiveFDs = select(max, readset, NULL, NULL, NULL);
  if (numActiveFDs < 0)
	end_curses(), perror("Select:"), exit(-1);

  return numActiveFDs;
}


void * Malloc(int size) {
	void *buf;

	buf = malloc(size); 
	if(!buf)
		perror("malloc"), exit(-1);

	return(buf);
}

char * Strdup(char *str) {
	char *buf;

	buf = strdup(str);
	if(!buf) 
		perror("strdup"), exit(-1);

	return(buf);
}

